import * as express from 'express';
import { Schema, Query, ObjectType, Field, Inject, compileSchema } from 'typegql';
import * as graphqlHTTP from 'express-graphql';

function InjectRequestedFields(allowed: string[]) {
  return Inject(({ info }) => {
    return info;
  });
}

class LazyObject {
  @Field() foo: string;
  @Field() bar: string;
}

@Schema()
class SuperSchema {
  @Query()
  foo(): LazyObject {
    return new LazyObject();
  }
}

const compiledSchema = compileSchema(SuperSchema);

const app = express();

app.use(
  '/graphql',
  graphqlHTTP({
    schema: compiledSchema,
    graphiql: true,
  }),
);
app.listen(3000);
